
@FunctionalInterface
interface My_functional_interface {

    void println(Object o);
}

public class Lambda_expression {

    public static void main(String[] args) {
        java.util.TimerTask timer_task = new java.util.TimerTask() {
            @Override
            public void run() {
                System.out.println("A behavior...");
            }
        };

        System.out.println(timer_task.getClass().getName());

        // This does not work because 'java.util.TimerTask' is an abstract class and not an interface:
        // java.util.TimerTask timer_task = () -> System.out.println("A behavior...");
        Runnable to_do = () -> {
            try {
                Thread.sleep(1000); // Nothing to do for 1 sec. <=> a kind of delay!
            } catch (InterruptedException ie) {
                java.util.logging.Logger.getLogger("Why it doesn't work?").log(java.util.logging.Level.SEVERE, null, ie);
            }
        };
        new Thread(to_do).start();

        My_functional_interface mfi = (o) -> System.out.println(o.toString());
    }
}
